Ext.define('DSS.component.TriggerConfigurator', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : '100%',
    grids : {},
    macPanel : null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    oButtonDelete : null,
    fEnableUsergroup : false,
    fIgnorePresence : false,
    fHeatingOperationMode:false,
    fSensorTrigger:false,
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight);
        this.iDefaultHeight = oHeight - 2;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false; 
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('group') != null)   // ist eine gruppe -> weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))   // ist ein device -> weiterbutton
        {
            fHasNext=true;
            var sTooltip=dss.staticDataModel.getTooltipForDevice(dss.staticDataModel.getDevice(record.get('dSUID')));
            if (sTooltip!="")
            	metadata.tdAttr = 'data-qtip="'+sTooltip+'"';
        }
        if (record.get('tooltip')!=null) {
        	if (record.get('tooltip')!="")
        		metadata.tdAttr = 'data-qtip="' + record.get('tooltip') + '"';
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) {
            fHasNext=false; // checkboxen niemals weiterbuttons
            fHasIcon=false; // keine Icons nach Checkboxen
            fIsCheckable=true;
        }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }
        
        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';      
    },
    initStores : function(fShowUserstates) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_l1Store') == null) {
            var Aktionen = [ {
                name : _('activity in room'),
                _id : 0,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }, {
                name : _('taster action'),
                _id : 1,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }, {
                name : _('user def. actions'),
                _id : 2,
                next : true,
                icon : null,
                passive:(dss.staticDataModel.getHLE().length==0)
            }, {
                name : _('automatic devices'),
                _id : 7,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getAKMDeviceArray().length==0)
            }, {
                name : _('zone trigger'),
                _id : 9,
                next : true,
                icon : null
            }, {
                name : _("consumptionmessage"),
                _id : 3,
                next : true,
                icon : null,
                passive:(dss.staticDataModel.getSensorDeviceArray().length==0)
            }];
            
            if (dss.staticDataModel.clusterAvaible)
            	Aktionen.push({
                    name : _('cluster trigger'),
                    _id : 11,
                    next : true,
                    icon : null,
                    passive:(dss.staticDataModel.getUsergroups().length==0)
                });
            
            if (dss.staticDataModel.heatingExtenderAvaible) {
            	var fAvaible=false;
            	for (var iIndex=0;iIndex<(dss.staticDataModel.deviceCache.length)&&(!fAvaible);iIndex++)
            		for (var jIndex=0;(jIndex<dss.staticDataModel.deviceCache[iIndex].sensors.length)&&(!fAvaible);jIndex++) {
            			if ((dss.staticDataModel.deviceCache[iIndex].sensors[jIndex].type==9) || 
            				(dss.staticDataModel.deviceCache[iIndex].sensors[jIndex].type==13))
            					fAvaible=true;
            		}
            	 Aktionen.push( {
                     name : _("sensor events"),
                     _id : 10,
                     next : true,
                     icon : null,
                     passive:!fAvaible
                 });
            }
            
            Aktionen.push({
                name : '-',
                _id : -1,
                passive:true,
                next : false,
                icon : null
            });
            Aktionen.push( {
                name : _("access trigger"),
                _id : 4,
                next : true,
                icon : null
            });
            Aktionen.push( {
                name : _('weather trigger'),
                _id : 5,
                next : true,
                icon : null
            });
            Aktionen.push( {
                name : _('security trigger'),
                _id : 6,
                next : true,
                icon : null
            });
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_l1Store',
                fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_l1Store').add(Aktionen);
            if (fShowUserstates) {
                Ext.data.StoreManager.lookup('triggerConfigurator_l1Store').add({
                    name : _('user states'),
                    _id : 8,
                    next : true,
                    icon : null,
                    passive:(dss.staticDataModel.getUserStates().length==0)
                });            	
            }
        }
        
    	if (Ext.data.StoreManager.lookup('triggerConfigurator_userStateStore') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_userStateStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            
    		var oUserStates=dss.staticDataModel.getUserStates();
    		
    		for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
       		 var sActiveName=Ext.String.format2(_('{state} is active'),{state:unescape(oUserStates[iIndex].name)});
    		 var sPassiveName=Ext.String.format2(_('{state} is inactive'),{state:unescape(oUserStates[iIndex].name)});
    			var Aktionen = [{
                    name : sActiveName,
                    _id : oUserStates[iIndex].id + '_active',
                    next : false,
                    icon : null
                },{
                	name : sPassiveName,
                    _id : oUserStates[iIndex].id + '_inactive',
                    next : false,
                    icon : null
                }];
    			Ext.data.StoreManager.lookup('triggerConfigurator_userStateStore').add(Aktionen);
    		}
            

    	}
        if (Ext.data.StoreManager.lookup('triggerConfigurator_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_zoneStore').add(dss.staticDataModel.getZoneArray());
        }
        if (Ext.data.StoreManager.lookup('triggerConfigurator_clusterStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_clusterStore',
                fields : [ 'id', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_clusterStore').add(dss.staticDataModel.getUsergroups());
        }
        if (Ext.data.StoreManager.lookup('triggerConfigurator_zoneSensorStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_zoneSensorStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oArray=dss.staticDataModel.getZoneArray();
            var deviceArray=dss.staticDataModel.getSensorDeviceArray();
            for (var iIndex=0;iIndex<oArray.length;iIndex++) {
                var fAdd=false;                
                for (var jIndex=0;jIndex<deviceArray.length;jIndex++) {
                    if (deviceArray[jIndex].ZoneID==oArray[iIndex].ZoneID)
                        fAdd=true;
                }                    
                if (fAdd) {
                    Ext.data.StoreManager.lookup('triggerConfigurator_zoneSensorStore').add(oArray[iIndex]);
                }
            }
        }
        if (Ext.data.StoreManager.lookup('triggerConfigurator_zoneAKMStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_zoneAKMStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oArray=dss.staticDataModel.getZoneArray();
            var deviceArray=dss.staticDataModel.getAKMDeviceArray();
            for (var iIndex=0;iIndex<oArray.length;iIndex++) {
                var fAdd=false;                
                for (var jIndex=0;jIndex<deviceArray.length;jIndex++) {
                    if (deviceArray[jIndex].ZoneID==oArray[iIndex].ZoneID)
                        fAdd=true;
                }                    
                if (fAdd) {
                    Ext.data.StoreManager.lookup('triggerConfigurator_zoneAKMStore').add(oArray[iIndex]);
                }
            }
        }
                
        if (Ext.data.StoreManager.lookup('triggerConfigurator_accessStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForScene(0, 0, 73),
                _id : 73,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 73)
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 72),
                _id : 72,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 72)
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 71),
                _id : 71,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 71)
            } ];
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_accessStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_accessStore').add(Aktionen);
        }
        
        if (Ext.data.StoreManager.lookup('triggerConfigurator_weatherStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForState('rain', 'active'),
                _id : 'rain_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('rain', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('rain', 'inactive'),
                _id : 'rain_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('rain', 'inactive')
            },{
            	name : dss.staticDataModel.getNameForState('wind', 'active'),
                _id : 'wind_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('wind', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('wind', 'inactive'),
                _id : 'wind_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('wind', 'inactive')
            },{
            	name : dss.staticDataModel.getNameForState('hail', 'active'),
                _id : 'hail_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('hail', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('hail', 'inactive'),
                _id : 'hail_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('hail', 'inactive')
            }];
            
            var fFrost=false;
            var fSun=false;
            var fHeating=false;
            var fService=false;
            for (var iIndex=0;iIndex<dss.staticDataModel.StateCache.length;iIndex++) {
            	if (dss.staticDataModel.StateCache[iIndex].name=='frost')
            		fFrost=true;
            	if (dss.staticDataModel.StateCache[iIndex].name=='sun')
            		fSun=true;
            	if (dss.staticDataModel.StateCache[iIndex].name=='heating_mode')
            		fHeating=true;
            	if (dss.staticDataModel.StateCache[iIndex].name=='service')
            		fService=true;
            }
            	
            if (fFrost) {
            	Aktionen.push({            
	                name : dss.staticDataModel.getNameForState('frost', 'active'),
	                _id : 'frost_active',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('frost', 'active')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('frost', 'inactive'),
	                _id : 'frost_inactive',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('frost', 'inactive')
	            });
            }
            
            if (fSun) {
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('sun', 'active'),
	                _id : 'sun_active',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('sun', 'active')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('sun', 'inactive'),
	                _id : 'sun_inactive',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('sun', 'inactive')
	            });
            }
            
            if (fHeating) {
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'off'),
	                _id : 'heating_mode_off',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'off')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'heating'),
	                _id : 'heating_mode_heating',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'heating')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'cooling'),
	                _id : 'heating_mode_cooling',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'cooling')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'auto'),
	                _id : 'heating_mode_auto',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'auto')
	            });
            }
            
            if (fService) {
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('service', 'active'),
	                _id : 'service_active',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('service', 'active')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('service', 'inactive'),
	                _id : 'service_inactive',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('service', 'inactive')
	            });
            }
            
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_weatherStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_weatherStore').add(Aktionen);
        }
        
        if (Ext.data.StoreManager.lookup('triggerConfigurator_securityStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForScene(0, 0, 65),
                _id : 65,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 65),
                _id : 1065,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65,true)
            },{
            	name : dss.staticDataModel.getNameForState('fire', 'active'),
                _id : 'fire_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('fire', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('fire', 'inactive'),
                _id : 'fire_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('fire', 'inactive')
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 74),
                _id : 74,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 74)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 74),
                _id : 1074,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 74,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 83),
                _id : 83,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 83)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 83),
                _id : 1083,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 83,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 84),
                _id : 84,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 84)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 84),
                _id : 1084,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 84,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 85),
                _id : 85,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 85)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 85),
                _id : 1085,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 85,true)
            }];
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_securityStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_securityStore').add(Aktionen);
        }
        
    },
    getGroupStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_groupStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_groupStore_' + ZoneID,
                fields : [ 'group', 'name', 'icon', 'reachable' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oGroup = dss.staticDataModel.getGroupForZone(ZoneID);
            Ext.data.StoreManager.lookup('triggerConfigurator_groupStore_' + ZoneID).add(oGroup);
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_groupStore_' + ZoneID);
    },
    getSceneStore : function(ZoneID, groupID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID,
                fields : [ '_id', 'name', 'reachable', 'icon', 'outputMode','forced' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oScenes = dss.staticDataModel.getScenes(ZoneID, groupID);
            for ( var iIndex = 0; iIndex < oScenes.length; iIndex++) {
                var oObject = {};
                oObject._id = oScenes[iIndex].id;
                oObject.reachable = oScenes[iIndex].reachable;
                oObject.icon = oScenes[iIndex].icon;
                if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                    oObject.name = oScenes[iIndex].name;
                else
                    oObject.name = oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
                
                if (oObject.undoable) {
                    oObject = {};
                    oObject._id = -1 * oScenes[iIndex].id;
                    oObject.reachable = oScenes[iIndex].reachable;
                    oObject.icon = oScenes[iIndex].icon;
                    if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                        oObject.name = _('Undo ') + oScenes[iIndex].name;
                    else
                        oObject.name = _('Undo ') + oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                    Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
                }
                
                if (oScenes[iIndex].id==0) {
                    if (groupID==2) {
                    	Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add({
                            _id:0,
                            name:_('all closed'),
                            icon: oScenes[iIndex].icon,
                            reachable : oScenes[iIndex].reachable,
                            forced:true
                        });
                    } else {
                    	Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add({
                            _id:0,
                            name:_('all off'),
                            icon: oScenes[iIndex].icon,
                            reachable : oScenes[iIndex].reachable,
                            forced:true
                        });
                    }
                }                
            }
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID);
    },
    getSensorMessage : function(dSUID)
    {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_sensorMessageStore_' + dSUID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_sensorMessageStore_' + dSUID,
                fields : [ 'name','_id'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getSensorDeviceArray();
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((dSUID==-1) || (oDeviceArray[iIndex].dSUID==dSUID)) {                
                    for (var jIndex=0;jIndex<oDeviceArray[iIndex].sensorEvents.length;jIndex++)
                        Ext.data.StoreManager.lookup('triggerConfigurator_sensorMessageStore_' + dSUID).add({name:oDeviceArray[iIndex].sensorEvents[jIndex].name,_id:oDeviceArray[iIndex].sensorEvents[jIndex].id});
                }
            }            
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_sensorMessageStore_' + dSUID);
    },
    getSensorDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceSensorStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceSensorStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getSensorDeviceArray();
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((ZoneID==0) || (ZoneID==oDeviceArray[iIndex].ZoneID))     
                        Ext.data.StoreManager.lookup('triggerConfigurator_deviceSensorStore_' + ZoneID).add(oDeviceArray[iIndex]);
            }
            
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_deviceSensorStore_' + ZoneID);
    },    
    getDeviceAKMStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceAKMStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceAKMStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getAKMDeviceArray();
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((ZoneID==0) || (ZoneID==oDeviceArray[iIndex].ZoneID))     
                	Ext.data.StoreManager.lookup('triggerConfigurator_deviceAKMStore_' + ZoneID).add(oDeviceArray[iIndex]);
            }
        }        
        return Ext.data.StoreManager.lookup('triggerConfigurator_deviceAKMStore_' + ZoneID);
    },
    getDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray = dss.staticDataModel.getDevicesForZone(ZoneID, 0);
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((oDeviceArray[iIndex].tasterMode==0)||(oDeviceArray[iIndex].tasterMode==15))
                    Ext.data.StoreManager.lookup('triggerConfigurator_deviceStore_' + ZoneID).add(oDeviceArray[iIndex]);

            }
        }        
        return Ext.data.StoreManager.lookup('triggerConfigurator_deviceStore_' + ZoneID);
    },
    constructGridLvlRoomStateState: function (zoneID) {
    	var oStates=dss.staticDataModel.getStates();
    	var oShowStates=[];
    	for (var iIndex=0;iIndex<oStates.length;iIndex++) {
    		var sSplitName=oStates[iIndex].name.split(".");
    		if (sSplitName.length==3)
    			if (sSplitName[0]=='zone')
    				if ((sSplitName[1]==''+zoneID) && (sSplitName[2] != 'heating')){
    					oShowStates.push(oStates[iIndex]);
    				}
    	}
    	oShowStates.sort(function (o1,o2) {if (o1.name<o2.name)return -1; else return 1;});
    		
        var oRoomStateStateControlStore = Ext.create('Ext.data.Store', {
            fields : [  'name','stateid','value','icon','tooltip','valueandstate'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oNewArray=[];
    	for (var iIndex=0;iIndex<oShowStates.length;iIndex++) {
    		var oNameArray=oShowStates[iIndex].name.split('.');
            var oItem={
            		'stateid':oShowStates[iIndex].name,
            		'value':'active',
            		'tooltip':"",
            		'icon': "",
            		'valueandstate':oShowStates[iIndex].name+'_active'};
            if (oNameArray[2]=='light') {
            	oItem.icon=dss.staticDataModel.getImagePathForScene(0,1,5);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}light is active"),{});
            }            	
            else if (oNameArray[2]=='motion') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(5,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}motion is active"),{});
            }            	
            else if (oNameArray[2]=='presence') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(1,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}presence is active"),{});
            }            	
            else {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(0,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}{state} is active"),{'state':oNameArray[2]});
            }            	
            oNewArray.push(oItem);
            
            oItem={
            		'stateid':oShowStates[iIndex].name,
            		'value':'inactive',
            		'tooltip':"",
            		'icon': "",
            		'valueandstate':oShowStates[iIndex].name+'_inactive'};
            if (oNameArray[2]=='light') {
            	oItem.icon=dss.staticDataModel.getImagePathForScene(0,1,0);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}light is inactive"),{});
            }
            else if (oNameArray[2]=='motion') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(5,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}motion is inactive"),{});
            }
            else if (oNameArray[2]=='presence') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(1,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}presence is inactive"),{});
            }            	
            else {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(0,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}{state} is inactive"),{'state':oNameArray[2]});
            }            	
            oNewArray.push(oItem);            
    	}
        oRoomStateStateControlStore.add(oNewArray);

    	
    	this.grids.lvlRoomStateState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 474,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomStateStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : this.defMacGridRenderer                
            } ]
        });

        this.grids.lvlRoomStateState.parent = this;

        this.macPanel.add(this.grids.lvlRoomStateState);
    	
    },
    constructGridLvlClusterStateState: function (clusterID) {
        var oStates = dss.staticDataModel.getStates();
        var oShowStates = [];
        for (var iIndex = 0; iIndex < oStates.length; iIndex++) {
            var sSplitName = oStates[iIndex].name.split(".");
            if ((sSplitName.length != 3) && (sSplitName[0] != 'cluster')) {
                continue;
            }
            if ((sSplitName[1] == ''+clusterID) && (sSplitName[2] == 'operation_lock')) {
                oShowStates.push(oStates[iIndex]);
            }
        }
        oShowStates.sort(function (o1,o2) { if (o1.name < o2.name) return -1; else return 1;});

        var oClusterStateStateControlStore = Ext.create('Ext.data.Store', {
            fields : [  'name', 'stateid', 'value', 'icon', 'tooltip', 'valueandstate'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oNewArray=[];
        for (var iIndex = 0; iIndex < oShowStates.length; iIndex++) {
            var oNameArray = oShowStates[iIndex].name.split('.');
            var oItem={
                    'stateid': oShowStates[iIndex].name,
                    'value': 'active',
                    'tooltip': "",
                    'icon': "",
                    'valueandstate': oShowStates[iIndex].name+'_active'};
            if (oNameArray[2] == 'operation_lock') {
                oItem.icon=dss.staticDataModel.getImagePathForState("operation_lock", "active");
                oItem.name=Ext.String.format2(_("{#editor_trigger_clusterstates}Operation is locked"),{});
            }
            oNewArray.push(oItem);

            oItem={
                    'stateid': oShowStates[iIndex].name,
                    'value': 'inactive',
                    'tooltip': "",
                    'icon': "",
                    'valueandstate': oShowStates[iIndex].name+'_inactive'};
            if (oNameArray[2] == 'operation_lock') {
                oItem.icon=dss.staticDataModel.getImagePathForState("operation_lock", "inactive");
                oItem.name=Ext.String.format2(_("{#editor_trigger_clusterstates}Operation is free"),{});
            }
            oNewArray.push(oItem);
        }
        oClusterStateStateControlStore.add(oNewArray);

        this.grids.lvlClusterStateState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 474,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oClusterStateStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('cluster'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlClusterStateState.parent = this;

        this.macPanel.add(this.grids.lvlClusterStateState);
    },
    constructGridLvlRoomStateRoom: function () {
        var oRoomStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
            	oRoomStateControlStore.add(oNewRecord);
        });
        oRoomStateControlStore.sort('name');
      
        this.grids.lvlRoomStateRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoomStateRoom.parent = this;
        this.grids.lvlRoomStateRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateState);
           
            var zoneID = record.get('ZoneID');
            this.parent.constructGridLvlRoomStateState(zoneID);           
        });
        this.macPanel.add(this.grids.lvlRoomStateRoom);
    },
    constructGridLvlClusterStateCluster: function () {
        var oClusterStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oClusterStore = Ext.data.StoreManager.lookup('triggerConfigurator_clusterStore');
        oClusterStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('id') != 0)
                oClusterStateControlStore.add(oNewRecord);
        });
        oClusterStateControlStore.sort('name');

        this.grids.lvlClusterStateCluster = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oClusterStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('cluster'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlClusterStateCluster.parent = this;
        this.grids.lvlClusterStateCluster.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlClusterStateState);

            var clusterID = record.get('id');
            this.parent.constructGridLvlClusterStateState(clusterID);
        });
        this.macPanel.add(this.grids.lvlClusterStateCluster);
    },
    constructGridLvlDeviceAKMValue : function (dSUID, type) {
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ 'name','_id','next','icon','tooltip','index' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oDevice=dss.staticDataModel.getDevice(dSUID);
        if (dss.staticDataModel.getDeviceType(oDevice) == 10) { //TNY
            for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
                if (oDevice.binaryInputs[iIndex].type == type) {
                    var oItem={
                            'index':oDevice.binaryInputs[iIndex].index,
                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
                            '_id':false,
                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false)};
                    oStore.add(oItem);
                    oItem={
                            'index':oDevice.binaryInputs[iIndex].index,
                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
                            '_id':true,
                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true)};
                    oStore.add(oItem);
                }
            }
            
        } else {
            var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);
            for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
                var oItem={
                		'index':oDevice.binaryInputs[iIndex].index,
                		'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
                		'_id':false,
                		'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
                		'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false)};
                oStore.add(oItem);
                if ((oDevice.binaryInputs[iIndex].type != 13) || (!bIsWindowHandle)) {
                    oItem={
                            'index':oDevice.binaryInputs[iIndex].index,
                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
                            '_id':true,
                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true)};
                    oStore.add(oItem);
                }
            }
        }
        this.grids.lvlDeviceAKMValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 150 + 174,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },           
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('type'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceAKMValue.parent = this;

        this.macPanel.add(this.grids.lvlDeviceAKMValue);
    }, 
    constructGridLvlDeviceAKMs : function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getDeviceAKMStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if ((oNewRecord.get('present'))||me.fIgnorePresence) {
                var oDevice = dss.staticDataModel.getDevice(oNewRecord.get('dSUID'));
                if (dss.staticDataModel.getDeviceType(oDevice) == 10 /*TNY*/) {
                    for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++) {
                            type=oDevice.binaryInputs[kIndex].type;
                            if (type!=255) {
                                var oInput = oNewRecord.copy();
                                var typeName = dss.staticDataModel.getNameForAKMType(type);
                                oInput.data.name = typeName;
                                oInput.data.type = type;
                                oDeviceControlStore.add(oInput);
                            }
                    }
                } else {
                	oDeviceControlStore.add(oNewRecord);
                }
            }
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlAKMDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlAKMDevice.parent = this;
        this.grids.lvlAKMDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            var type = record.get('type');
            this.parent.constructGridLvlDeviceAKMValue(dSUID, type);
        });
        this.macPanel.add(this.grids.lvlAKMDevice);
    },
    constructGridLvlAKM:function (){
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneAKMStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        this.grids.lvlAKMRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlAKMRoom.parent = this;
        this.grids.lvlAKMRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlUserstate);

            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlDeviceAKMs(zoneID);
        });
        this.macPanel.add(this.grids.lvlAKMRoom);
    },
    constructGridLvlDeviceActions : function(dSUID) {
        var oDeviceActionControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id', 'name', 'icon', 'next' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oDeviceObject = dss.staticDataModel.getDevice(dSUID);

        if (oDeviceObject.tasterMode == 15) {
            if (oDeviceObject.buttonType==2) {
                oDeviceActionControlStore.add({
                    _id : 1000,
                    name : _('switch down'),
                    icon : null,
                    next : false
                });
                oDeviceActionControlStore.add({
                    _id : 1001,
                    name : _('switch up'),
                    icon : null,
                    next : false
                });
            } else if ((oDeviceObject.buttonType>=16) && (oDeviceObject.buttonType<=21)) {
                oDeviceActionControlStore.add({
                    _id : 1002,
                    name : _('switch down'),
                    icon : null,
                    next : false
                });
                oDeviceActionControlStore.add({
                    _id : 1003,
                    name : _('switch up'),
                    icon : null,
                    next : false
                });
            } else {                        
                oDeviceActionControlStore.add({
                    _id : 0,
                    name : _('1x click'),
                    icon : null,
                    next : false
                });
                oDeviceActionControlStore.add({
                    _id : 1,
                    name : _('2x click'),
                    icon : null,
                    next : false
                });
                oDeviceActionControlStore.add({
                    _id : 2,
                    name : _('3x click'),
                    icon : null,
                    next : false
                });
                oDeviceActionControlStore.add({
                    _id : 3,
                    name : _('4x click'),
                    icon : null,
                    next : false
                });
                oDeviceActionControlStore.add({
                    _id : 6,
                    name : _('hold'),
                    icon : null,
                    next : false
                });
                /*oDeviceActionControlStore.add({
                    _id : 10,
                    name : 'Kurz-Lang',
                    icon : null,
                    next : false
                });*/
            }
        } else {
            oDeviceActionControlStore.add({
                _id : 50,
                name : _('local off'),
                icon : null,
                next : false
            });
            oDeviceActionControlStore.add({
                _id : 51,
                name : _('local on'),
                icon : null,
                next : false
            });
        }

        this.grids.lvlDeviceAction = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oDeviceActionControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('taster action'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceAction.parent = this;

        this.macPanel.add(this.grids.lvlDeviceAction);

    },    
    constructGridLvlAccess : function() {

        this.grids.lvlAccess = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_accessStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlAccess.parent = this;

        this.grids.lvlAccess.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlAccess);

    },
    constructGridLvlWeather : function() {


        this.grids.lvlWeather = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_weatherStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlWeather.parent = this;

        this.grids.lvlWeather.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlWeather);
    },
    constructGridLvlUserstate : function() {


        this.grids.lvlUserstate = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_userStateStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlUserstate.parent = this;

        this.grids.lvlUserstate.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlUserstate);
    },
    constructGridLvlPanic : function() {

        this.grids.lvlPanic = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_securityStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlPanic.parent = this;

        this.grids.lvlPanic.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlPanic);
    },
    constructGridLvlDevice : function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getDeviceStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            var fAKM=false;
            for (var iIndex=0;iIndex<dss.staticDataModel.getAKMDeviceArray().length;iIndex++) {
            	if (oNewRecord.get('dSUID')==dss.staticDataModel.getAKMDeviceArray()[iIndex].dSUID)
            		fAKM=true;
            }            
            if (!fAKM)
                if ((oNewRecord.get('present'))||me.fIgnorePresence)
                    oDeviceControlStore.add(oNewRecord);
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDevice.parent = this;
        this.grids.lvlDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceActions(dSUID);
        });
        this.macPanel.add(this.grids.lvlDevice);
    },
    constructGridLvlGroupScene : function(zoneID, groupID, fAll, fForced) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForced == null)
            fForced = false;
        if (zoneID==-1)
            zoneID=0;
        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            _id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            _id : -1,
            name : '-',
            passive:true,
            icon : null,
            reachable : true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable') || fAll)
                if (oNewRecord.get('_id') < 64)
                    oSceneControlStore.add(oNewRecord);
        });

        this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlScene.parent = this;

        this.grids.lvlScene.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }

            if (record.get('checkable') != null)
                if (record.get('checkable')) {
                    this.getSelectionModel().deselect(record);
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('_id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            _id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });
                        grid.store.add({
                            _id : -1,
                            name : '-',
                            passive:true,
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('_id') < 64)
                                    grid.store.add(oNewRecord);
                        });

                    }
                }

        });
        this.macPanel.add(this.grids.lvlScene);

    },
    constructGridLvlRoom : function() {
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        if (this.grids.lvl1.getSelectionModel().getSelection()[0].get('_id') == 0) {
            oZoneControlStore.add({
                'ZoneID' : -1,
                'name' : _('any room')
            });
        }
        this.grids.lvlRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoom.parent = this;
        this.grids.lvlRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('_id') == 0) {
                var zoneID = record.get('ZoneID');
                if (zoneID == -1)
                    zoneID = 0;
                this.parent.constructGridLvlGroup(zoneID);
            } else if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('_id') == 1) {
                var zoneID = record.get('ZoneID');
                if (zoneID == -1)
                    zoneID = 0;
                this.parent.constructGridLvlDevice(zoneID);
            }
        });
        this.macPanel.add(this.grids.lvlRoom);
    },
    constructGridLvlHigh : function() {
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ {name:'name',sortType:'asUCText'} ,'_id'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (dss.staticDataModel.HLECache!=null)
            if (dss.staticDataModel.HLECache.length>0) {
                for (var iIndex=0;iIndex<dss.staticDataModel.HLECache.length;iIndex++)
                    oStore.add( {   
                        name:dss.staticDataModel.HLECache[iIndex].name,
                        _id:dss.staticDataModel.HLECache[iIndex].id
                    });
            }
        oStore.sort('name','ASC');
        this.grids.lvlHighLevelEvent = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('user def. actions'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr style="height:16px;"><td width="100%">' + record.get('name') + '</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlHighLevelEvent.parent = this;
        this.macPanel.add(this.grids.lvlHighLevelEvent);
    },
    constructGridLvlGroup : function(zoneID) {
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id', 'group', 'name', 'icon', 'reachable' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroupStore = this.getGroupStore(zoneID);
        oGroupStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable')) {
            	var fOK=true;
            	switch (oNewRecord.get('group')) {
	            	case 0:
	            	case 6:
	            	case 7:
	            	case 8:
	            	case 16:
	            	case 17:
	            	case 18:
	            	case 19:
	            	case 20:
	            	case 21:
	            	case 22:
	            	case 23:
		            	fOK=false;
		            	break; 
            	}
                if (fOK) {
                    oGroupControlStore.add(oNewRecord);
                }
            }
        });
        oGroupControlStore.add({
            group : -1,
            name : '-',
            passive:'-',
            icon : null,
            reachable : true
        });
        var oSceneGroup0Store;
        if (zoneID == 0)
            oSceneGroup0Store = this.getSceneStore(dss.staticDataModel.getZoneArray()[1].ZoneID, 0);
        else
            oSceneGroup0Store = this.getSceneStore(zoneID, 0);
        oSceneGroup0Store.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable'))
                oGroupControlStore.add(oNewRecord);
        });

        this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('activity'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlGroup.on('itemclick', function(grid, record) {
            if (record.get('group') == -1) {
                grid.getSelectionModel().deselect(record);
                return;
            }

            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('_id') == 0) {
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = record.get('group');
                if ((zoneID != null) && (groupID != null)) {
                    this.parent.constructGridLvlGroupScene(zoneID, groupID);
                    this.getSelectionModel().deselectAll();
                    this.getSelectionModel().select(record);
                }
                if (groupID == null) {
                    grid.store.each(function(record) {
                        if (record.get('group') != null)
                            grid.getSelectionModel().deselect(record);
                    });
                }
            }
        });

        this.grids.lvlGroup.parent = this;
        this.macPanel.add(this.grids.lvlGroup);
    },
    constructGridLvlSensorMessage:function (dSUID) {
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ 'name' ,'_id'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oSensorMessageStore = this.getSensorMessage(dSUID);
        oSensorMessageStore.each(function(record) {
            var oNewRecord = record.copy();
            oStore.add(oNewRecord);
        });
        
        this.grids.lvlSensorMessage = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('message'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr style="height:16px;"><td width="100%">' + record.get('name') + '</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlSensorMessage.parent = this;
        this.macPanel.add(this.grids.lvlSensorMessage);
    },
    constructGridLvlSensorDevice:function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getSensorDeviceStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if ((oNewRecord.get('present'))||me.fIgnorePresence)
                oDeviceControlStore.add(oNewRecord);
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlSensorDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlSensorDevice.parent = this;
        this.grids.lvlSensorDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlSensorMessage(dSUID);
        });
        this.macPanel.add(this.grids.lvlSensorDevice);
    },
    constructGridLvlSensor:function (){
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneSensorStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        this.grids.lvlSensorRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlSensorRoom.parent = this;
        this.grids.lvlSensorRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            this.parent.macPanel.remove(this.parent.grids.lvlUserstate);

            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlSensorDevice(zoneID);
        });
        this.macPanel.add(this.grids.lvlSensorRoom);
    },
    constructMacGrids : function() {
        var lvl1Store;
    	if (this.grids.lvl1==null) {
	        var lvl1TempStore = Ext.create('Ext.data.Store', {
	            fields : [ '_id', 'name', 'next', 'icon' ],
	            proxy : {
	                type : 'memory',
	                reader : {
	                    type : 'json',
	                    root : 'items'
	                }
	            }
	        });
	
	        lvl1Store = Ext.data.StoreManager.lookup('triggerConfigurator_l1Store');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            lvl1TempStore.add(oNewRecord);
	        });
	        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
	            hideHeaders:true,
	            height : this.iDefaultHeight,
	            width : this.iDefaultWidth,
	            autoScroll : true,
	            viewConfig : {
	                stripeRows : true
	            },
	            selModel : {
	                mode : 'MULTI'
	            },
	            store : lvl1TempStore,
	            columns : [ {
	                sortable : false,
	                hideable : false,
	                text : _('Action'),
	                dataIndex : 'name',
	                flex : 1,
	                renderer : this.defMacGridRenderer
	            } ]
	        });
	        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
	        this.grids.lvl1.parent = this;
	
	        this.grids.lvl1.on('itemclick', function(grid, record) {
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlHighLevelEvent);
	            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
	            this.parent.macPanel.remove(this.parent.grids.lvlScene);
	            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlSensorRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);            
	            this.parent.macPanel.remove(this.parent.grids.lvlWeather);
	            this.parent.macPanel.remove(this.parent.grids.lvlPanic);
	            this.parent.macPanel.remove(this.parent.grids.lvlAccess);
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
	            this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlAKMRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlUserstate);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateState);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlClusterStateCluster);
	            this.parent.macPanel.remove(this.parent.grids.lvlClusterStateState);
	            
	            var fIsPassive=false;
	            if (record.get('passive')!=null) {
	                if (record.get('passive')==true) {
	                    this.getSelectionModel().deselect(record);
	                    fIsPassive=true;
	                }
	            }
	            if (!fIsPassive) {
	                if (record.get('_id') == 0) {
	                    this.parent.constructGridLvlRoom();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 1) {
	                    this.parent.constructGridLvlRoom();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 2) {
	                    this.parent.constructGridLvlHigh();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 3) {
	                    this.parent.constructGridLvlSensor();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 4) {
	                    this.parent.constructGridLvlAccess();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 5) {
	                    this.parent.constructGridLvlWeather();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 6) {
	                    this.parent.constructGridLvlPanic();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 7) {
	                    this.parent.constructGridLvlAKM();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 8) {
	                    this.parent.constructGridLvlUserstate();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else if (record.get('_id') == 9) {
	                    this.parent. constructGridLvlRoomStateRoom();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);	                    
	                } else if (record.get('_id') == 11) {
	                    this.parent.constructGridLvlClusterStateCluster();
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                } else {
	                    grid.store.each(function(record) {
	                        if (record.get('_id') < 7)
	                            grid.getSelectionModel().deselect(record);
	                    });
	                }
	            }
	            this.parent.macPanel.doLayout();
	        }); 
    	} else {
        	this.grids.lvl1.getStore().removeAll();
        	var mThis=this;        	
	        lvl1Store = Ext.data.StoreManager.lookup('triggerConfigurator_l1Store');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            mThis.grids.lvl1.getStore().add(oNewRecord);
	        });
    	}

    },
    constructor : function(config) {
    	var mThis=this;
        this.fEnableUsergroup=false;
        if (config.enableUsergroup!=null)
        	this.fEnableUsergroup=config.enableUsergroup;
        
    	this.ShowUserstates=false;
        if (config.userStates)
        	this.ShowUserstates=config.userStates;
        
        this.fHeatingOperationMode=false;
        if (config.heatingOperationMode!=null)
        	this.fHeatingOperationMode=config.heatingOperationMode;

        this.fIgnorePresence=false;
        if (config.ignorePresence!=null)
        	this.fIgnorePresence=config.ignorePresence;

        
        Ext.data.StoreManager.on('clear',function () {mThis.initStores(mThis.ShowUserstates);mThis.constructMacGrids();});
        
        this.initStores(this.ShowUserstates);
        this.constructMacGrids();

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            autoScroll : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            scroll : 'horizontal'
        });
        Ext.apply(this, {
            items : [ this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
        this.setValue([]);
    },
    setValue : function(values) {

        this.macPanel.remove(this.grids.lvlDeviceAction);
        this.macPanel.remove(this.grids.lvlRoom);
        this.macPanel.remove(this.grids.lvlHighLevelEvent);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlDevice);
        this.macPanel.remove(this.grids.lvlSensorRoom);
        this.macPanel.remove(this.grids.lvlSensorDevice);
        this.macPanel.remove(this.grids.lvlSensorMessage);
        this.macPanel.remove(this.grids.lvlWeather);
        this.macPanel.remove(this.grids.lvlPanic);
        this.macPanel.remove(this.grids.lvlAccess);        
        this.macPanel.remove(this.grids.lvlDeviceAKMValue);
        this.macPanel.remove(this.grids.lvlAKMDevice);
        this.macPanel.remove(this.grids.lvlAKMRoom);
        this.macPanel.remove(this.grids.lvlUserstate);
        this.macPanel.remove(this.grids.lvlRoomStateState);
        this.macPanel.remove(this.grids.lvlRoomStateRoom);
        this.macPanel.remove(this.grids.lvlClusterStateCluster);
        this.macPanel.remove(this.grids.lvlClusterStateState);
        
        var fGridConstructed = false;

        this.grids.lvl1.getSelectionModel().deselectAll();

        if (values.length==0)
        {
            //this.grids.lvl1.getSelectionModel().select(0,false,true);
            //this.constructGridLvlRoom();
        }
        
        for ( var vIndex = 0; vIndex < values.length; vIndex++) {
            var oValue = values[vIndex];
            switch (oValue.type) {
                case 'device-sensor':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',3,false,false,true),true);                    	
                        this.constructGridLvlSensor();
                        var oRecordZone = this.grids.lvlSensorRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlSensorRoom.getSelectionModel().select(oRecordZone);
                        else 
                            break;
                        this.constructGridLvlSensorDevice(zoneID);
                        var oRecordDevice = this.grids.lvlSensorDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlSensorDevice.getSelectionModel().select(oRecordDevice);
                        else 
                            break;
                        this.constructGridLvlSensorMessage(oValue.dsuid);
                    }
                     var iIndex=this.grids.lvlSensorMessage.store.find('_id', oValue.eventid,0,false,false,true);
                    if (iIndex!=-1)
                        this.grids.lvlSensorMessage.getSelectionModel().select(iIndex,true);
                break;

                case 'device-binary-input':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);                    	
                        this.constructGridLvlRoom();
                        var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlDevice(zoneID);
                        var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else
                            break;
                        this.constructGridLvlDeviceActions(oValue.dsuid);
                    }
                     if (oValue.state==1) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1002,0,false,false,true);      
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    }
                    if (oValue.state==0) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1003,0,false,false,true);      
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    }
                    
                break;

                case 'device-msg':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);                    	

                        this.constructGridLvlRoom();
                        var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlDevice(zoneID);
                        var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else
                            break;
                        this.constructGridLvlDeviceActions(oValue.dsuid);
                    }
                    if ((oValue.msg == 0) && (oValue.buttonIndex!=null)) {
                        if (oValue.buttonIndex==2) {
                            var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1000,0,false,false,true);      
                            if (iIndex!=-1)
                                this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                        }
                        if (oValue.buttonIndex==1) {
                            var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1001,0,false,false,true);      
                            if (iIndex!=-1)
                                this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                        }
                    } else if (oValue.msg == 7) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 0,0,false,false,true);      
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else if (oValue.msg == 8) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else if (oValue.msg == 9) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 2,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', oValue.msg,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    }

                break;
                case 'undo-zone-scene': {
                    if (oValue.zone == 0)                    	
                    	switch (oValue.scene) {
		                	case 65:		                	
		                	case 74:
		                	case 83:
		                	case 84:
		                	case 85:
		                		if (!fGridConstructed) {
		                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);                    	
			                        this.constructGridLvlPanic();
		                		}
	                    		var oRecordScene = this.grids.lvlPanic.store.find('_id', 1000+oValue.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
		            		break;
		            	}
                }
                break;
                case 'addon-state-change': {
                	if (oValue["addon-id"]=='user-defined-states') {
                		var stateName=oValue.name.split('_')[1];
                		if (!fGridConstructed) {
                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',8,false,false,true),true);                    	
                            this.constructGridLvlUserstate();
                		}
                		var oRecordScene = this.grids.lvlUserstate.store.find('_id', stateName + '_' + oValue.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlUserstate.getSelectionModel().select(oRecordScene,true);
                        break;                    	
                	}
                	break;
                }
                case 'state-change':
                	//  name, state : 'active', 'inactive'
                	var oArray=oValue.name.split('.');
                	if (oArray.length==3) {
	                	if (oArray[0]=='dev')
	                	{
	                		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
	                		if (oDevice!=null) {
	                			if (!fGridConstructed) {
	                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',7,false,false,true),true);                    	
	                                this.constructGridLvlAKM();
		                			var oRecordZone=this.grids.lvlAKMRoom.store.find('ZoneID', oDevice.ZoneID,0,false,false,true);
		                            if (oRecordZone != -1) {
		                                this.grids.lvlAKMRoom.getSelectionModel().select(oRecordZone,true);
		                                this.constructGridLvlDeviceAKMs(oDevice.ZoneID);
		                                var oRecordDevice=this.grids.lvlAKMDevice.store.find('dSUID', oArray[1],0,false,false,true);
			                            if (oRecordDevice != -1) {
			                            	this.grids.lvlAKMDevice.getSelectionModel().select(oRecordDevice,true);
			                            	this.constructGridLvlDeviceAKMValue(oArray[1]);
			                            }
		                            }
	                			}
	                				                			                			
	                			var oRecordValue=this.grids.lvlDeviceAKMValue.store.findBy(function(record) {
	                				if (record.get('index')==parseInt(oArray[2],10))
	                					if (record.get('_id')==(oValue.state=='active'))
	                						return true;
	                				return false;
	                			});

	                			if (oRecordValue != -1)
	                				this.grids.lvlDeviceAKMValue.getSelectionModel().select(oRecordValue,true);
	                			break;
	                		}
	                	}
	                	if (oArray[0]=='zone') {
	                		if (!fGridConstructed) {
                                this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',9,false,false,true),true);
                                this.constructGridLvlRoomStateRoom();
                            	var oRecordZone=this.grids.lvlRoomStateRoom.store.find('ZoneID', parseInt(oArray[1],10),0,false,false,true);
	                            if (oRecordZone != -1) {
	                            	this.grids.lvlRoomStateRoom.getSelectionModel().select(oRecordZone,true);
	                            	this.constructGridLvlRoomStateState(parseInt(oArray[1],10));
	                            	var oRecordState=this.grids.lvlRoomStateState.getStore().find('valueandstate',oValue.name+'_'+oValue.state);
	                            	if (oRecordState!=null)
	                            		this.grids.lvlRoomStateState.getSelectionModel().select(oRecordState);
	                            	
	                            }
	                            break;
	                		}
	                	}
                        if (oArray[0] == 'cluster') {
                            if (!fGridConstructed) {
                                this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',9,false,false,true),true);
                                this.constructGridLvlClusterStateCluster();
                                var oRecordZone=this.grids.lvlClusterStateCluster.store.find('id', parseInt(oArray[1],10),0,false,false,true);
                                if (oRecordZone != -1) {
                                    this.grids.lvlClusterStateCluster.getSelectionModel().select(oRecordZone,true);
                                    this.constructGridLvlClusterStateState(parseInt(oArray[1],10));
                                    var oRecordState=this.grids.lvlClusterStateState.getStore().find('valueandstate',oValue.name+'_'+oValue.state);
                                    if (oRecordState!=null) {
                                        this.grids.lvlClusterStateState.getSelectionModel().select(oRecordState);
                                    }
                                }
                                break;
                            }
                        }
                	}
                	if (oValue.name=='fire') {
                		if (!fGridConstructed) {
                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);                    	
                            this.constructGridLvlPanic();
                		}
                		var oRecordScene = this.grids.lvlPanic.store.find('_id', oValue.name + '_' + oValue.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
                	} else {
                		if (!fGridConstructed) {
                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',5,false,false,true),true);                    	
                            this.constructGridLvlWeather();
                		}
                		var oRecordScene = this.grids.lvlWeather.store.find('_id', oValue.name + '_' + oValue.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlWeather.getSelectionModel().select(oRecordScene,true);                		
                	}
                	
                break;
                case 'zone-scene':
                    if (oValue.zone == 0) {
                    	
                    	switch (oValue.scene) {
	                    	case 65:
	                    	case 74:
	                    	case 83:
	                    	case 84:
	                    	case 85:
	                    		if (!fGridConstructed) {
	                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);                    	
		                            this.constructGridLvlPanic();
	                    		}
	                    		var oRecordScene = this.grids.lvlPanic.store.find('_id', oValue.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
                    		break;
	                    	case 73:
	                    	case 72:
	                    	case 71:
	                    		if (!fGridConstructed) {
	                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',4,false,false,true),true);                    	
		                            this.constructGridLvlAccess();
	                    		}
	                    		var oRecordScene = this.grids.lvlAccess.store.find('_id', oValue.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlAccess.getSelectionModel().select(oRecordScene,true);
                    		break;
                    	}
                    	
                    	
                    
                    } else {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',0,false,false,true),true);                    	
                        if (!fGridConstructed) {                        	
                            this.constructGridLvlRoom();
                            var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oValue.zone,0,false,false,true);
                            if (oRecordZone != -1)
                                this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                            else {
                           
                            	break;
                            }
                                
                            if (oValue.zone == -1)
                                this.constructGridLvlGroup(0);
                            else
                                this.constructGridLvlGroup(oValue.zone);
                        }
                        if (oValue.group == 0) {
                            var oRecordGroup = this.grids.lvlGroup.store.find('_id', oValue.scene,0,false,false,true);
                            if (oRecordGroup != -1)
                                this.grids.lvlGroup.getSelectionModel().select(oRecordGroup,true);
                            else {
                            	
                                break;
                            }
                        } else {
                            var oRecordGroup = this.grids.lvlGroup.store.find('group', oValue.group,0,false,false,true);
                            if (oRecordGroup != -1)
                                this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                            else {
                            	
                                break;
                            }
                            if (!fGridConstructed) {
                                this.constructGridLvlGroupScene(oValue.zone, oValue.group, false, false);
                            }
                            var oRecordScene = this.grids.lvlScene.store.find('_id', oValue.scene,0,false,false,true);
                            if (oRecordScene != -1) {
                            	if (oValue.forced!=null)
                            		if (oValue.forced)
                            			oRecordScene++;
                                this.grids.lvlScene.getSelectionModel().select(oRecordScene,true);
                            } else {
                                this.macPanel.remove(this.grids.lvlScene);
                                if (!fGridConstructed) {
                                    this.constructGridLvlGroupScene(oValue.zone, oValue.group, true, false);
                                }
                                var oRecordScene = this.grids.lvlScene.store.find('_id', oValue.scene,0,false,false,true);
                                if (oRecordScene != -1) {
                                	if (oValue.forced!=null)
                                		if (oValue.forced)
                                			oRecordScene++;
                                    this.grids.lvlScene.getSelectionModel().select(oRecordScene,true);
                                } else {
                                
                                    break;
                                }
                            }

                        }
                    }
                  
                break;
                case 'device-scene':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);                    	
                        this.constructGridLvlRoom();
                        var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlDevice(zoneID);
                        var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else 
                            break;
                        this.constructGridLvlDeviceActions(oValue.dsuid);
                    }
                    var iIndex = this.grids.lvlDeviceAction.store.find('_id', oValue.scene,0,false,false,true);
                    if (iIndex != -1)
                        this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);

                break;
                case 'custom-event':
                    if (!fGridConstructed)
                        this.constructGridLvlHigh();
                	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',2,false,false,true),true);                    	
                    var oRecord = this.grids.lvlHighLevelEvent.store.find('_id', oValue.event,0,false,false,true);
                    if (oRecord != -1)
                        this.grids.lvlHighLevelEvent.getSelectionModel().select(oRecord,true);
                break;
            }
            fGridConstructed = true;
        }
    },
    isValid : function() {
        var oValue = this.getValue();
        return (oValue.length > 0);
    },
    getValue : function() {
        var oReturnValue = [];
        try {
            var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
            for ( var iIndex = 0; iIndex < oSelectionLVL1.length; iIndex++) {
            
                if (oSelectionLVL1[iIndex].get('_id') == 4) {
                	// access trigger
                	var oSelectionScene = this.grids.lvlAccess.getSelectionModel().getSelection();
                	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	if (oSelectionScene[kIndex].get('_id')<1000) {
	                    	var oObject = {
	                            type : 'zone-scene',
	                            zone : 0,
	                            group : 0,
	                            scene : oSelectionScene[kIndex].get('_id')
	                        };
	                        oReturnValue.push(oObject);
                    	} else {
                    		 var oObject = {
                				 type : 'undo-zone-scene',
                				 zone : 0,
                				 group : 0,
                				 scene : oSelectionScene[kIndex].get('_id')-1000
            				 }; 
                    		 oReturnValue.push(oObject);
                    	}
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 9) {
                	var oSelectionScene = this.grids.lvlRoomStateState.getSelectionModel().getSelection();
                	// zonestate
                 	//  name, state : 'active', 'inactive' 	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	var sValue=oSelectionScene[kIndex].get('value');
                    	var stateName=oSelectionScene[kIndex].get('stateid');
                    	var oObject = {
	                            type : 'state-change',
	                            name : stateName,
	                            state : sValue
	                        };
	                    oReturnValue.push(oObject);                    	
                    }
                }                
                if (oSelectionLVL1[iIndex].get('_id') == 11) {
                    var oSelectionScene = this.grids.lvlClusterStateState.getSelectionModel().getSelection();
                    // clusterstate
                    //  name, state : 'active', 'inactive'
                    for (var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                        var sValue = oSelectionScene[kIndex].get('value');
                        var stateName = oSelectionScene[kIndex].get('stateid');
                        var oObject = {
                                type : 'state-change',
                                name : stateName,
                                state : sValue
                            };
                        oReturnValue.push(oObject);
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 8) {
                	var oSelectionScene = this.grids.lvlUserstate.getSelectionModel().getSelection();
                	// usertate
                 	//  name, state : 'active', 'inactive' 	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	var sValue=oSelectionScene[kIndex].get('_id');
                    	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
                    	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
                    	var oObject = {
	                            type : 'addon-state-change',
	                            name : "uds_" + stateName,
	                            state : stateValue, 
	                            addonId:"user-defined-states"
	                        };
	                    oReturnValue.push(oObject);                    	
                    }
                }                
                if (oSelectionLVL1[iIndex].get('_id') == 5) {
                	var oSelectionScene = this.grids.lvlWeather.getSelectionModel().getSelection();
                	// weather
                 	//  name, state : 'active', 'inactive' 	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	var sValue=oSelectionScene[kIndex].get('_id');
                    	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
                    	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
                    	var oObject = {
	                            type : 'state-change',
	                            name : stateName,
	                            state : stateValue
	                        };
	                    oReturnValue.push(oObject);                    	
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 6) {
                	var oSelectionScene = this.grids.lvlPanic.getSelectionModel().getSelection();
                	// panic
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	if ((""+oSelectionScene[kIndex].get('_id')).indexOf('_')>=0) {
                        	var sValue=oSelectionScene[kIndex].get('_id');
                        	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
                        	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
                        	var oObject = {
    	                            type : 'state-change',
    	                            name : stateName,
    	                            state : stateValue
    	                        };
    	                    oReturnValue.push(oObject);                    	
                    	} else 
                    	if (oSelectionScene[kIndex].get('_id')<1000) {
	                    	var oObject = {
	                            type : 'zone-scene',
	                            zone : 0,
	                            group : 0,
	                            scene : oSelectionScene[kIndex].get('_id')
	                        };
	                        oReturnValue.push(oObject);
                    	} else {
                    		 var oObject = {
                				 type : 'undo-zone-scene',
                				 zone : 0,
                				 group : 0,
                				 scene : oSelectionScene[kIndex].get('_id')-1000
            				 }; 
                    		 oReturnValue.push(oObject);
                    	}
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 7) {
                	var oSelectionDevice = this.grids.lvlAKMDevice.getSelectionModel().getSelection()[0].get('dSUID');
                	var oSelectionIndex = this.grids.lvlDeviceAKMValue.getSelectionModel().getSelection()[0].get('index');                	
                	var oSelectionValue = this.grids.lvlDeviceAKMValue.getSelectionModel().getSelection()[0].get('_id');
                    var oDevice=dss.staticDataModel.getDevice(oSelectionDevice);
                    var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);

                    // device states
                	var oObject = {
                            type : 'state-change',
                            name : 'dev.' + oSelectionDevice + '.' + oSelectionIndex,
                            state : (oSelectionValue ?'active':'inactive')
                        };
                    oReturnValue.push(oObject);     
                    if ((bIsWindowHandle) && (oSelectionIndex == 1) && (!oSelectionValue)) {
                        var oObject = {
                                type : 'state-change',
                                name : 'dev.' + oSelectionDevice + '.' + '0',
                                state : (!oSelectionValue ?'active':'inactive')
                            };
                        oReturnValue.push(oObject);                             
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 0) { // zone scene
                    var iZoneID = this.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                    var oSelectionGroup = this.grids.lvlGroup.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionGroup.length; jIndex++) {
                        if (oSelectionGroup[jIndex].get('group') == null) {
                            var oObject = {
                                type : 'zone-scene',
                                zone : iZoneID,
                                group : 0,
                                scene : oSelectionGroup[jIndex].get('_id')
                            };
                            oReturnValue.push(oObject);
                        } else {
                            var iGroupID = oSelectionGroup[jIndex].get('group');
                            var oSelectionScene = this.grids.lvlScene.getSelectionModel().getSelection();
                            for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                                var oObject = {
                                    type : 'zone-scene',
                                    zone : iZoneID,
                                    group : iGroupID,
                                    scene : oSelectionScene[kIndex].get('_id')                                    
                                };
                                if (oSelectionScene[kIndex].get('forced')!=null)
                                    if (oSelectionScene[kIndex].get('forced')!="")
                                    	oObject.forced=oSelectionScene[kIndex].get('forced');
                                //else
                                //	oObject.forced=false;
                                oReturnValue.push(oObject);
                            }
                        }
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 1) { // taster
                    var oDSID = this.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                    var oDSUID = this.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSUID');
    
                    var oSelectionDeviceAction = this.grids.lvlDeviceAction.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionDeviceAction.length; jIndex++) {
                        if ((oSelectionDeviceAction[jIndex].get('_id') > 15) && (oSelectionDeviceAction[jIndex].get('_id') < 1000)) {
                            var oObject = {
                                dsid : oDSID,
                                dsuid : oDSUID,
                                type : 'device-scene',
                                scene : oSelectionDeviceAction[jIndex].get('_id')
                            };
                            oReturnValue.push(oObject);
                        } else {
                            if (oSelectionDeviceAction[jIndex].get('_id') == 0) {
                                var oObject1 = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 0
                                };
                                oReturnValue.push(oObject1);
                                var oObject2 = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 7
                                };
                                oReturnValue.push(oObject2);
                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1) {
                                var oObject1 = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 1
                                };
                                oReturnValue.push(oObject1);
                                var oObject2 = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 8
                                };
                                oReturnValue.push(oObject2);
                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 2) {
                                var oObject1 = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 2
                                };
                                oReturnValue.push(oObject1);
                                var oObject2 = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 9
                                };
                                oReturnValue.push(oObject2);
                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1000) {
                                var oObject1 = {  //switch down
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 0,
                                    buttonIndex: 2
                                };
                                oReturnValue.push(oObject1);
                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1001) {
                                var oObject1 = { //switch up
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : 0,
                                    buttonIndex: 1
                                };
                                oReturnValue.push(oObject1);
                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1002) {
                                var oObject1 = {  //switch down
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-binary-input',
                                    index : 0,
                                    state: 1
                                };
                                oReturnValue.push(oObject1);
                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1003) {
                                var oObject1 = { //switch up
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-binary-input',
                                    index : 0,
                                    state: 0
                                };
                                oReturnValue.push(oObject1);
                            } else {
                                var oObject = {
                                    dsid : oDSID,
                                    dsuid : oDSUID,
                                    type : 'device-msg',
                                    msg : oSelectionDeviceAction[jIndex].get('_id')
                                };
                                oReturnValue.push(oObject);
                            }
                        }
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 2) { // highlvl
                    var oSelectionHighLVL = this.grids.lvlHighLevelEvent.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionHighLVL.length; jIndex++) {
                        var oObject = {
                            type : 'custom-event',
                            event : oSelectionHighLVL[jIndex].get('_id')
                        };
                        oReturnValue.push(oObject);
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 3) { // sensor
                    var oDSID = this.grids.lvlSensorDevice.getSelectionModel().getSelection()[0].get('dSID');
                    var oDUSID = this.grids.lvlSensorDevice.getSelectionModel().getSelection()[0].get('dSUID');
                    var oSelectionMSG = this.grids.lvlSensorMessage.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionMSG.length; jIndex++) {
                        var oObject = {
                            type : 'device-sensor',
                            dsid :oDSID, 
                            dsuid :oDSUID, 
                            eventid : oSelectionMSG[jIndex].get('_id')
                        };
                        oReturnValue.push(oObject);
                    }
                }
            }
        } 
        catch (e){}
        return oReturnValue;
    }
}); // DSS.component.ActionConfigurator

